<template>
<div class="contenido">
  <vue-headful title="Hack a Flight | SEARCH" />
  <body>
    <link
      rel="stylesheet"
      href="https://use.fontawesome.com/releases/v5.6.3/css/all.css"
      integrity="sha384-UHRtZLI+pbxtHCWp1t77Bi1L4ZtiqrqD80Kn4Z8NTSRyMA2Fd33n5dQ8lWUE00s/"
      crossorigin="anonymous"
    />

    <h1>Empieza a buscar tu próximo viaje</h1>

    <p v-show="errorMsg">*Tienes campos vacios</p>

    <div class="container"></div>

    <i class="fas fa-plane-departure"></i>
    <input type="text" v-model="origen" placeholder="Origen" />
    <i class="fas fa-plane-arrival"></i>
    <input type="text" v-model="destino" placeholder="Destino" />
    <div>
      <i class="fas fa-euro-sign"></i>
      <input type="text" v-model="precioMax" placeholder="Precio máximo en €" />
      <i class="fas fa-hourglass-start"></i>
      <input type="text" v-model="horasMax" placeholder="Duración en horas máxima" />
      <i class="fas fa-hourglass-end"></i>
      <input type="text" v-model="minutosMax" placeholder="Duracion máxima minutos" />
    </div>
    <div>
      <i class="fas fa-route"></i>
      <input type="number" v-model="paradasMax" id="number" placeholder="Escalas" name="quantity" />
      <i class="fas fa-user-alt"></i>
      <input type="number" v-model="adultos" id="number" placeholder="Pasajeros" />
      <i class="fas fa-calendar-alt"></i>
      <input
        type="date"
        id="start"
        name="trip-start"
        v-model="salida"
        value="2020-08-04"
        min="2020-01-01"
        max="2020-12-31"
      />
    </div>
    <button class="registerbtn" @click="validatingData()">Buscar vuelos</button>
    <br />
    <br />
    <br />
    <!-- <spinner @click="ratito()" v.show="seeSpinner" /> -->
    <li v-for="flight in flights" :key="flight.id">
      <div class="courses-container">
        <div class="course">
          <div class="course-preview">
            <h4>Vuelo</h4>
            <h1>{{origen.toUpperCase()}} {{destino.toUpperCase()}}</h1>
          </div>
          <div class="course-info">
            <div class="progress-container">
              <link
                rel="stylesheet"
                href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
              />
              <div class="progress"></div>
            </div>
            <h3>Fecha: {{salida}}</h3>
            <!-- <h2>Id: {{ flight.id }}</h2> -->
            <h2>Aerolinea: {{ flight.AirlineCode }}</h2>
            <h2>Duracion total: {{flight.duration}}</h2>
            <h2>Escalas: {{flight.stops}} · Pasajeros: {{adultos}}</h2>
            <h2>Precio: {{flight.price}}</h2>
            <button class="btn" @click="reservaCliente()">Reservar</button>
          </div>
        </div>
        <br />
      </div>
    </li>
    <!-- <li v-for="flight in flights" :key="flight.id">
      <p>Itinerario: {{origen.toUpperCase()}} - {{destino.toUpperCase()}}</p>
      <p>Fecha: {{salida}}</p>
      <p>Precio: {{flight.price}}</p>
      <p>Duracion: {{flight.duration}}</p>
      <p>Paradas: {{flight.stops}}</p>
      <button @click="reservaCliente()">Reservar</button>
    </li>-->
  </body>
</div>
</template>


<script>
import cors from "cors";
import axios from "axios";
//import searchcomponent from "@/components/SearchComponent.vue";
//import flightcard from "@/components/FlightCard.vue";
import Swal from "sweetalert2";
import vueHeadful from "vue-headful";
import Spinner from "@/components/Spinner.vue";

const airlines = require("iata-airlines");
/* console.log(index.lookupByIataCode('EWR'));
console.log(index.searchByAirportName('Newark')); */

/* import { library } from '@fortawesome/fontawesome-svg-core'
import { fas } from '@fortawesome/free-solid-svg-icons'


library.add(fas) */

export default {
  name: "Search",
  components: {
    Spinner,
  },
  data() {
    return {
      origen: "",
      destino: "",
      precioMax: "",
      horasMax: "",
      minutosMax: "",
      paradasMax: "",
      salida: "", 
      adultos: "",
      flights: [],
      errorMsg: false,
      seeSpinner: true,
    };
  },
  methods: {
    ratito() {
      setTimeout(() => {
        this.seeSpinner = false;
      }, 3000);
    },
    validatingData() {
      if (
        this.origen === "" ||
        this.destino === "" ||
        this.precioMax === "" ||
        this.horasMax === "" ||
        this.minutosMax === "" ||
        this.paradasMax === "" ||
        this.salida === "" ||
        this.adultos === ""
      ) {
        this.errorMsg = true;
        this.getAllFlights = false;
      } else {
        this.errorMsg = false;
        this.getAllFlights();
      }
      Swal.fire({
     title: "Buscando vuelo",
     text: "Espere mientras realizamos la búsqueda.",
     imageUrl: "https://i.gifer.com/ZZ5H.gif",
     imageHeight: 50,
     timer: 3500
     });
    },

    getAllFlights(origen, destino, precioMax, horasMax, minutosMax, paradasMax, salida, adultos) {
      var self = this;
      axios.get(`http://localhost:9000/flights?originLocationCode=${this.origen.toUpperCase()}&destinationLocationCode=${this.destino.toUpperCase()}&maxPrice=${this.precioMax}&maxHours=${this.horasMax}&maxMinutes=${this.minutosMax}&maxStops=${this.paradasMax}&departureDate=${this.salida}&adults=${this.adultos}`)
        .then(function (response) {
          self.flights = response.data;
          console.log(response.data);
        })
        .catch(function (error) {
          console.log(error);
        });
    },
    reservaCliente() {
      Swal.fire({
        title: "¡Vuelo reservado!",
        onClose: () => {
          location.reload;
        },
      });
    },
  },
  created() {
    this.getAllFlights();
  },
};
</script>

<style scoped>
.contenido {
  font-family: "Source Sans Pro", sans-serif;
  display: block;
  margin: auto;
  text-align: center;
  padding-inline-start: 0px;
}
i {
  padding: 15px;
}
#number {
  width: 8em;
}
body,
input {
  padding-left: 1rem;
  font-size: 1.5rem;
  padding: 0.5rem 1rem;
}
.course {
  background-color: #fff;
  border-radius: 20px;
  border-spacing: 20px;
  box-shadow: 5px 10px 10px rgba(0, 0, 0, 0.3);
  display: flex;
  max-width: 75%;
  margin: auto;
  overflow: hidden;
  text-align: center;
}

.course h6 {
  opacity: 0.6;
  margin: 0;
  letter-spacing: 1px;
  text-transform: uppercase;
}

.course h2 {
  letter-spacing: 1px;
  margin: 10px 0;
}

.course-preview {
  background-color: black;
  color: #fff;
  padding: 30px 100px;
  max-width: 250px;
}

.course-preview a {
  color: #fff;
  display: inline-block;
  font-size: 12px;
  opacity: 0.6;
  margin-top: 30px;
  text-decoration: none;
}

.course-info {
  padding: 20px;
  position: relative;
  width: 100%;
}

.btn {
  background-color: black;
  border: 0;
  border-radius: 10px;
  box-shadow: 0 10px 10px rgba(0, 0, 0, 0.2);
  color: #fff;
  font-size: 22px;
  padding: 12px 25px;
  position: absolute;
  bottom: 30px;
  right: 30px;
  letter-spacing: 1px;
}
.btn:hover {
  opacity: 0.4;
}
* {
  box-sizing: border-box;
}

/* Add padding to containers */
.container {
  padding: 16px;
  background-color: white;
  text-align: center;
  align-items: center;
  justify-content: center;
}

/* Full-width input fields */
input[type="text"],
input[type="number"],
input[type="date"] {
  font-size: 26px;
  padding: 15px;
  margin: 5px 0px 22px 0;
  display: inline-block;
  border-color: white;
  border-style: solid;
  background: #f1f1f1;
}

input[type="text"]:focus,
input[type="date"]:focus {
  font-size: 26px;
  background-color: #ddd;
  outline: none;
}

/* Overwrite default styles of hr */
hr {
  border: 1px solid #f1f1f1;
  margin-bottom: 25px;
}

/* Set a style for the submit button */
.registerbtn {
  font-size: 26px;
  background-color: black;
  color: white;
  padding: 20px 40px;
  margin: 8px 0;
  border: none;
  cursor: pointer;
}

.registerbtn:hover {
  opacity: 0.4;
}
</style>